#ifndef _TEST_SEQUENCE_BROWSER_HPP_
#define _TEST_SEQUENCE_BROWSER_HPP_

#include <QtGui>
#include <QtTest/QtTest>

#include "alg/sequence.hpp"
#include "qui/seqbrowser/SequenceBrowser.hpp"

#include <iostream>
#include <string>
#include <vector>

#include <boost/assign.hpp>
#include <boost/shared_ptr.hpp>
using namespace boost::assign;


class TestSequenceBrowser : public QObject
{
  Q_OBJECT

private slots:

  void testSimplePushSequence() {
    boost::shared_ptr<Sequence> seq1(new Sequence("AAGGCCTT"));
    boost::shared_ptr<Sequence> seq2(new Sequence("GGCCTTAA"));

    SequenceBrowser browser;
    QVERIFY(browser.sequences().size() == 0);
    browser.push_sequence(seq1);
    browser.push_sequence(seq2);
    QVERIFY(browser.sequences().size() == 2);
    browser.clear();
    QVERIFY(browser.sequences().size() == 0);
  }

  void testSelect() {
    boost::shared_ptr<Sequence> seq1(new Sequence("AAGGCCTT"));
    boost::shared_ptr<Sequence> seq2(new Sequence("GGCCTTAA"));

    SequenceBrowser browser;
    browser.push_sequence(seq1);
    browser.push_sequence(seq2);
    std::vector<int> path; path += 1,1;
    std::vector<bool> rc; rc += false, false;
    browser.link(path, rc, 2);
  }
};
#endif
